/*
*  WhatsNew utility
*  
*  source/mydblib.h
*  snapshot 20040131
*  
*  (c) 27.3.2002, 24.12.2003 Jaroslav Beran berk@volny.cz http://www.volny.cz/berk
*  License GNU/GPL2  
*/


#include <stdio.h>
#include <sys/types.h>


#define DB_DIVIDER ';'
#define MAX_ENTRY_LEN 1024
#define MAX_DB_LINE 10240


struct h_entry {
        char *source;
        char *file;
        off_t size;
        time_t modified;
        time_t explored_created;
        time_t explored_deleted;
        mode_t mode;
        FILE *f;
        long last_pos;
        long filter_origin;
        long filter_end;
};


extern FILE *open_table(struct h_entry *entry, char *db_path, char *table, char *mode);
extern int close_table(struct h_entry *entry);

extern int put_rec(struct h_entry *entry);
extern int get_next_rec(struct h_entry *entry, char *buff, int max);
extern int find_rec(struct h_entry *entry, char *buff, int max, char *source, char *file);

extern int set_table_filter(struct h_entry *entry, char *source);
extern int out_of_filter(struct h_entry *entry);
extern void seek_top(struct h_entry *entry);

extern void transfer_fields(struct h_entry *target, struct h_entry *source);
