/*
*  WhatsNew utility
*  
*  source/pidfile.c
*  snapshot 20040119
*  
*  (c) 27.3.2002, 24.12.2003 Jaroslav Beran berk@volny.cz http://www.volny.cz/berk
*  License GNU/GPL2  
*/


#include <stdio.h>
#ifdef __linux__
#include <unistd.h>
#else
#include <io.h>
#include <process.h>
#endif


int create_pidfile(char *s)
{
        FILE *f;


        if (s == NULL)
                return -1;

        if (access(s, F_OK) == 0){
                fprintf(stderr, "create_pidfile: pid file %s already exists\n", s);
                return -2;
        }

        if ((f = fopen(s, "w")) == NULL){
                fprintf(stderr, "create_pidfile: can't create file %s\n", s);
                return -3;
        }

        fprintf(f, "%d\n", getpid());

        fclose(f);
        return 0;
}


int erase_pidfile(char *s)
{
        if (s == NULL)
                return -1;

        return remove(s);
}
