/*
*  WhatsNew utility
*  
*  source/statistics.c
*  snapshot 20040208
*  
*  (c) 27.3.2002, 24.12.2003 Jaroslav Beran berk@volny.cz http://www.volny.cz/berk
*  License GNU/GPL2  
*/


#include <time.h>
#include "statistics.h"


void st_start(struct s_stat *st)
{
        st->start = clock();
        st->stop = 0;
        st->all_files = 0;
        st->new_files = 0;
        st->modified_files = 0;
        st->deleted_files = 0;

        return;
}


void st_stop(struct s_stat *st)
{
        st->stop = clock();
        return;
}


void st_print(FILE *f, struct s_stat *st)
{
        double deset,
               sec,
               min,
               hod,
               speed;


        if (f == NULL)
                return;

        deset = (st->stop - st->start) / (double) CLOCKS_PER_SEC;

        if (deset == 0)
                speed = 0;
        else
                speed = st->all_files / deset;

        sec = (unsigned) deset / 1;
        deset = (deset - sec) * 10;
        min = (unsigned) sec / 60;
        sec -= min * 60;
        hod = (unsigned) min / 60;
        min -= hod * 60;

        fprintf(f, "time:\t\t%02.0f:%02.0f:%02.0f.%02.0f\n", hod, min, sec, deset);
        fprintf(f, "files:\t\t%ld\n", st->all_files);

        if (st->all_files > 0) {
                fprintf(f, "speed:\t\t%-.1f files/sec\n", speed);
                fprintf(f, "new:\t\t%ld\n", st->new_files);
                fprintf(f, "modified:\t%ld\n", st->modified_files);
                fprintf(f, "deleted:\t%ld\n", st->deleted_files);
        }

        return;
}


void st_add(struct s_stat *target, struct s_stat *source)
{
        target->all_files += source->all_files;
        target->new_files += source->new_files;
        target->modified_files += source->modified_files;
        target->deleted_files += source->deleted_files;

        return;
}
